what4-1.5.1: Solver-agnostic symbolic values support for issuing queries

Safe Haskell | Trustworthy
Language | Haskell2010

What4.Panic

Synopsis

- type HasCallStack = ?callStack :: CallStack
- data What4
- data Panic a
- panic :: HasCallStack => String -> [String] -> a

# Documentation

type HasCallStack = ?callStack :: CallStack Source #

Request a CallStack.

NOTE: The implicit parameter `?callStack :: CallStack` is an implementation detail and should not be considered part of the `CallStack` API, we may decide to change the implementation in the future.

Since: base-4.9.0.0

data What4 Source #

#### Instances

Instances details

PanicComponent What4 Source # |
Instance details Defined in What4.Panic Methods panicComponentName :: What4 -> String Source # panicComponentIssues :: What4 -> String Source # panicComponentRevision :: What4 -> (String, String) Source #

data Panic a Source #

The exception thrown when panicing.

#### Instances

Instances details

PanicComponent a => Exception (Panic a) |
Instance details Defined in Panic Methods toException :: Panic a -> SomeException Source # fromException :: SomeException -> Maybe (Panic a) Source # displayException :: Panic a -> String Source #
PanicComponent a => Show (Panic a) |
Instance details Defined in Panic Methods showsPrec :: Int -> Panic a -> ShowS Source # show :: Panic a -> String Source # showList :: [Panic a] -> ShowS Source #

panic Source #

Arguments

:: HasCallStack |
=> String | Short name of where the error occured
-> [String] | More detailed description of the error
-> a |

`panic` represents an error condition that should only arise due to a programming error. It will exit the program and print a message asking users to open a ticket.